/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <exports.h>
#include <asm/addrspace.h>
#include <asm/io.h>


#define VR7701_PCI_PINTXMASK		KSEG1ADDR(0x18840058)
static void check(void);
int hello_world (int argc, char *argv[])
{
	int i;

	/* Print the ABI version */
	app_startup(argv);
	printf ("Example expects ABI version %d\n", XF_VERSION);
	printf ("Actual U-Boot ABI version %d\n", (int)get_version());

	printf ("Hello World\n");
	printf ("argc = %d\n", argc);

	for (i=0; i<argc; ++i) {
		printf ("argv[%d] = \"%s\"\n",
			i,
			argv[i] ? argv[i] : "<NULL>");
	}
	check();

	printf ("Hit any key to exit ... ");
	while (!tstc())
		;
	/* consume input */
	(void) getc();

	printf ("\n\n");
	return (0);
}

void check()
{
	unsigned int count;
	int mask=1;
	for ( count = 0; count < 10000000; count++ ) {
		writel( mask, VR7701_PCI_PINTXMASK );
		if ( readl( VR7701_PCI_PINTXMASK ) != mask ) {
			printf( "write error count=%d mask=%x\n", count, mask );
			return;
		}
		if ( !(count % 10000) ) printf( "." );
		mask ^= 1;
	}
}
